BMapCom.Controller.create(function() {
    var isMonkeyTest = BMapCom.config('isMonkeyTest');
    var globalData = {
        domain: 'http://dianying.baidu.com'
    };

    function $(q) {
        return document.querySelector(q);
    }

    function jsonToUrl(obj) {
        var strArr = [],
            key;

        for (key in obj) {
            if (obj.hasOwnProperty(key)) {
                strArr.push(key + '=' + obj[key]);
            }
        }

        return strArr.join('&');
    }

    return {
        initWithPage: function(activityListPage, activityListTpl) {
            var self = this;

            activityListPage
                .delegate({
                    shouldWaiting: function() {
                        return true;
                    },
                    onCreate: function(pageParam, ready) {
                        globalData.pageParam = pageParam;

                        self.getActivity()
                            .then(function(data) {
                                activityListPage.append(activityListTpl.body(self.fixData(data)));
                                self.bindPageEvent();

                                BMapCom.Kernel.notify('webPageReady');
                            });
                    },
                    onDestory: function() {}
                });
        },
        bindPageEvent: function() {
            var evt = new BMapCom.EventDelegater($('.al-wrapper'));

            evt.on('gotoAct:tap', function(e) {
                var url = this.getAttribute('data-url'),
                    disable = this.getAttribute('data-disable');
                if (isMonkeyTest) {
                    return;
                }
                //已结束的活动不跳转
                if(disable == "1"){
                    return;
                }
                var entranceParam = {
                    "page": "defaultWebViewPage",
                    "pageParam": {
                        "url": url
                    }
                };
                BMapCom.Kernel.notify('changePage', entranceParam);
            });
        },
        getActivity: function() {
            return new BMapCom.Promise(function(resolve, reject) {
                var actListSource = new BMapCom.DataSource();

                actListSource
                    .delegate({
                        search: function() {
                            var self = this,
                                storageKey = 'lsk-actlist',
                                urlParams = {
                                    'from': 'webview',
                                    'sfrom': 'map',
                                    'type': 1,
                                    'interface_direct_tag': 1
                                },
                                url = globalData.domain + "/info/operation/list?" + jsonToUrl(urlParams);

                            return BMapCom.Loader.jsonp(url)
                                .ok(function(result) {
                                    BMapCom.storage.setLocalStorage(storageKey, result.data, 5);
                                    self.onSourceLoadFinish(result.data);
                                })
                                .error(function() {
                                    self.onSourceLoadFailed();
                                });
                        }
                    })
                    .delegate({
                        onSourceLoadFinish: function(result) {
                            resolve(result);
                        },
                        startSourceLoad: function(opts) {
                            this.search(opts);
                        },
                        onSourceLoadFailed: function() {}
                    });

                actListSource.update();
            });
        },
        fixData: function(data) {
            var fixData = data.data,
                text,
                item;

            for (var key in fixData) {
                if (fixData.hasOwnProperty(key)) {
                    item = fixData[key];

                    if (key == 'now') {
                        text = '火热进行中';
                    } else if (key == 'future') {
                        text = '即将开始';
                    } else if (key == 'before') {
                        text = '已结束';
                    }

                    fixData[key].label = text;
                    item.forEach(function(act, i) {
                        var dateObj = new Date(parseInt(act.start_time) * 1000);
                        act.startDate = dateObj.getFullYear() + '年' + (dateObj.getMonth() + 1) + '月' + dateObj.getDate() + '日';
                        act.dateLeft = (parseInt(act.end_time) - parseInt(act.start_time)) / 86400000;
                    });
                }
            }

            return {
                data: fixData
            }
        }
    }
});