BMapCom.Controller.create(function() {

    var $ = function(q) {
        return document.querySelector(q)
    };

    var pageParamCache = {};

    var renderAll = function(bigImagePage, bigImageTpl, result) {
        var list = result.image.list;
        var fixedData = [];

        fixedData = list.map(function(item) {
            var data = {};
            if (imageSource.param && imageSource.param.imageFrom == 'baidumap') {
                data.imageUrl = item.link_mobilephone || '';
            } else {
                data.imageUrl = item.imgUrl || '';
            }
            data.userName = item.username || '';
            data.cnName = item.cn_name || '';
            data.comment = item.content || '';
            if (data.comment && data.comment.length > 15) {
                data.lessComment = data.comment.substr(0, 15) + '...';
            }
            return data;
        });

        fixedData.index = (pageParamCache.option) ? (pageParamCache.option.index || 0) : 0;
        BMapCom.Plugin.use('SlideView').then(function(SlideView) {
            SlideView.instantiate(fixedData, $('#bigImageContainer'));
        });
    }

    var imageSourceDelegate = {
        search: function(uid, imageFrom, sort) {
            var self = this;
            //http://client.map.baidu.com/detail?qt=allpic&ugcPic=0&triPic=10&uid=7aea43b7204d94e17c29bd34
            var domain = "http://client.map.baidu.com/detail?"
            var param;
            if (imageFrom == 'baidumap') {
                //百度地图图片
                param = [
                    'qt=ugcpic',
                    'maxResults=10',
                    'startIndex=0',
                    'orderBy=' + (sort ? sort : 2),
                    'uid=' + uid
                ].join('&');
            } else {
                //所有来源图片
                param = [
                    'qt=allpic',
                    'ugcPic=0',
                    'triPic=10',
                    'uid=' + uid
                ].join('&');
            }
            var url = domain + param;
            console.log(url);

            return BMapCom.Loader.jsonp(url)
                .ok(function(result) {
                    self.onSourceLoadFinish(result.data);
                })
                .error(function() {
                    self.onSourceLoadFailed();
                });

        }
    };

    var bindPageEvent = function() {
        var evt = new BMapCom.EventDelegater($('#bigImageContainer'));
        evt.on('commentMore:tap', function(e) {
            this.parentNode.style.display = 'none';
            BMapCom.util.$nextNode(this.parentNode).style.display = '';
        });
        evt.on('commentLess:tap', function(e) {
            this.parentNode.style.display = 'none';
            BMapCom.util.$prevNode(this.parentNode).style.display = '';
        });
    };

    var imageSource;

    var initMethod = function(bigImagePage, bigImageTpl) {
        bigImagePage.append(bigImageTpl.body());

        imageSource = new BMapCom.DataSource();
        imageSource
            .delegate(imageSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    renderAll(bigImagePage, bigImageTpl, result);
                    bindPageEvent();
                    BMapCom.Kernel.notify('webPageReady');
                },
                startSourceLoad: function(param) {
                    this.param = param;
                    this.search(param.uid, param.imageFrom, param.sort);
                }
            });
        bigImagePage
            .delegate({
                shouldWaiting: function() {
                    return true;
                },
                onCreate: function(pageParam, ready) {
                    pageParamCache = pageParam;
                    var promise = new BMapCom.Promise(function(fulfill, reject) {
                        BMapCom.Loader.script('lib/iScroll.js')
                            .ok(function() {
                                fulfill();
                            })
                            .error(function() {
                                reject({});
                            })
                    });
                    promise.then(function() {
                        if (pageParam.renderImmediately) {
                            renderAll(bigImagePage, bigImageTpl, pageParam.option.imageList);
                            bindPageEvent();
                        } else {
                            var param = {
                                uid: pageParam.uid
                            };
                            if (pageParam.option && pageParam.option.imageFrom && pageParam.option.sort) {
                                param.imageFrom = pageParam.option.imageFrom;
                                param.sort = pageParam.option.sort;
                            }
                            imageSource.update(param);
                        }
                    });

                },
                onDestory: function() {
                    renderContainer.innerHTML = "";
                }
            });

    }


    return {
        initWithPage: initMethod
    }
});