BMapCom.Controller.create(function() {
    // mokey test需封住的出口
    var isMonkeyTest = BMapCom.config('isMonkeyTest');

    var $ = function(q) {
        return document.querySelector(q);
    };

    var THUMB_DOMAIN = 'http://map.baidu.com/maps/services/thumbnails',
        pageParamCache = {},
        pointCurrent = {};

    // 发送数据请求
    var movieDetailSourceDelegate = {
        search: function(uid) {
        
            var self = this,
                LOCAL_BOOK_STORAGE_KEY = "lsk-moviebook-detail-" + uid,
                resultData = BMapCom.storage.getLocalStorage(LOCAL_BOOK_STORAGE_KEY);

            if (resultData) {
                self.onSourceLoadFinish(resultData);
            } else {
                var domain = "http://map.baidu.com/detail?";
                //var domain = 'http://cp01-rdqa-pool392.cp01.baidu.com:8081/detail?';
                var param = [
                    'qt=timetable',
                    'from=webview',
                    'sfrom=map',
                    'v=2',
                    'uid=' + uid
                ].join('&');

                var url = domain + param;
            
                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data.length != 0) {
                            BMapCom.storage.setLocalStorage(LOCAL_BOOK_STORAGE_KEY, result.data, 5);
                            self.onSourceLoadFinish(result.data);
                        }
                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            }
        }
    }
    var poiDetailSourceDelegate = {
        search: function(uid) { 
            var self = this,
                LOCAL_STORAGE_KEY = "lsk-movie-detail-" + uid,
                resultData = BMapCom.storage.getLocalStorage(LOCAL_STORAGE_KEY);
            if (resultData) {
                self.onSourceLoadFinish(resultData);
            } else {
                var domain = 'http://map.baidu.com/detail?';
                var param = [
                    'qt=ninf',
                    'from=webview',
                    'sfrom=map',
                    'uid=' + uid
                ].join('&');

                var url = domain + param;
                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data && result.data.content) { 
                            BMapCom.storage.setLocalStorage(LOCAL_STORAGE_KEY, result.data, 5);
                            self.onSourceLoadFinish(result.data);
                        }
                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            }
        }
    }
    var grouponDetailSourceDelegate = {
        search: function(uid) {
            var self = this,
                LOCAL_BOOK_STORAGE_KEY = "lsk-moviebook-groupon-" + uid,
                resultData = BMapCom.storage.getLocalStorage(LOCAL_BOOK_STORAGE_KEY);
            if (resultData) {
                self.onSourceLoadFinish(resultData);
            } else {
                var domain = "http://openapi.se.nuomi.com/bnapi/api/query?";
                var param = [
                    'poiuid=' + uid,
                    'tn=mapapp',
                    'type=poigroupon',
                    'city=1',
                    's=101'
                ].join('&');

                var url = domain + param;
                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data.length != 0) {
                            BMapCom.storage.setLocalStorage(LOCAL_BOOK_STORAGE_KEY, result.data, 5);
                            self.onSourceLoadFinish(result.data);
                        }
                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            }
        }
    }

    //对请求数据组装
    var fixData = function(content) {

        var di = {};
        var tags = [],
            tels;

        if (content.ext && content.ext.detail_info) {
            di = content.ext.detail_info;
        }
        var ri = {};
        if (content.ext && content.ext.rich_info) {
            ri = content.ext.rich_info;
        }

        if (di.phone) {
            tels = di.phone.split(',');
        }
        var end_addr = content.addr;
        if(content.addr.length > 27){
            end_addr = content.addr.substring(0,27) + "...";
        }
        var result = {
            'uid': content.uid,
            'name': content.name,
            'addr': end_addr || '',
            'point': content.ext.detail_info.point,
            'price': di.price,
            'picNum': di.image_num || 0,
            'vista': content.vista,
            'level': ri.level || '',
            'headPic': di.image ? (THUMB_DOMAIN + '?width=150&height=120&quality=100&align=center,center&src=' + encodeURI(di.image)) : 'style/img/basic-info-pic-empty.png',
            'tel': tels && tels[0],
            'comment_num': di.comment_num,
            'tag': di.tag,
            "shop_hours": content.ext.rich_info.shop_hours,
            "groupon": di.groupon,
            "groupon_num": di.groupon_num,
            "premium2": di.premium2,
            "rating": di.overall_rating,
            "vip": di.flag_on_left,
            "zhidahao": di.zhidahao
        };
        return result;
    }
    var fixCommentData = function(detailData) {
        if (!detailData.ext || !detailData.ext.review) {
            return null;
        };
        var review = detailData.ext.review;
        
        var result = {
                'showHead': true,
                'showSort': false,
                'showSeeMoreFoot': true,
                'showLoadMoreFoot': false,
                'title': '评论',
                'total': detailData.ext.detail_info ? detailData.ext.detail_info.comment_num : '',
                'comments': []
            }
            //评论信息
            //获取真实展示的评论数,仅展示2条，按来源顺序优先抽取，不足2条从下一组来源中获取并填充
        var showComments = [];
        var sourceIndex = 0;
        var source = review[0];
        while (source && source.info) {
            showComments = showComments.concat(
                source.info.slice(0, source.info.length)
                .map(function(comment) {
                    comment.cn_name = source.cn_name;
                    return comment;
                }));
            source = review[++sourceIndex];
        }
        // 
        var mlength = showComments.length,
            comments_mid = new Array();
        for (var m = 0; m < mlength; m++) {
            if (typeof(showComments[m].name) != "undefined" && showComments[m].name == "baidumap" && showComments[m].cn_name == "百度地图") {
                comments_mid.push(showComments[m]);
            }
        }
        showComments = comments_mid;
        //可能填充的数量大于2，此处一次性裁切
        showComments = showComments.slice(0, 10);
        result.comments = showComments.map(function(item) {
            item.username = item.user_name || (item.cn_name + '网友');

            item.ratingLevel = (item.rating) ? item.rating * 20 + "%" : ((item.overall_rating) ? item.overall_rating * 20 + "%" : 0);
            item.rating = (item.rating) ? item.rating : ((item.overall_rating) ? item.overall_rating : 0);

            // item.price = 230;
            if (item.content && item.content.length > 50) {
                item.lessContent = item.content.substr(0, 50) + '...';
            }
            return item;
        });
        return result;
    }
    var fixBindData = function(detailData) {
        var content = detailData.content;
        var di = {};
        if (content.ext && content.ext.detail_info) {
            di = content.ext.detail_info;
        }
        var result = {
            "uid": content.uid,
            "poiName": content.name || "",
            "tel": content.phone,
            "address": content.addr,
            'price': di.price,
            "imageUrl": di.image || "",
            "pointX": di.point ? di.point.x : "",
            "pointY": di.point ? di.point.y : "",
            "cityId": content.city_id || 0,
            'headPic': di.image ? BMapCom.util.getThumbUrl(di.image, 75, 60) : null,
            "premiumFlag": di.premium_flag || 0,
            "commentNum": di.comment_num,
            "tag": di.tag
        };
        if (di.overall_rating) {
            result.rating = parseFloat(di.overall_rating).toFixed(1);
        } else {
            result.rating = '';
        }

        //墨卡托转换为经纬度
        // function mercatorToCoordinates (point) {
        //    return {
        //         x:point.x/20037508.34*180,
        //         y:180/Math.PI*(2*Math.atan(Math.exp(point.y/20037508.34*180*Math.PI/180))-Math.PI/2)
        //     }
        // }
        // var point_middle = mercatorToCoordinates({x:di.point.x, y:di.point.y});
        //point地理位置数据给全局变量pointCurrent
        // pointCurrent = {
        //         "pointX": point_middle.x?(point_middle.x + "").substr(0,10):"",
        //         "pointY": point_middle.y?(point_middle.y + "").substr(0,10):""
        //     }
        pointCurrent = {
                "pointX": di.point.x?di.point.x:"",
                "pointY": di.point.y?di.point.y:""
            }
        return result;
    }

    /*
    *渲染页面
    */
    //附近影院
    function loadNearbyCinema(detailTpl, params) {

        var nearbyDC = new BMapCom.DataSource();
        nearbyDC
            .delegate({
                search: function(params) {
                    var self = this,
                        storageKey = 'lsk-nearby-' + params.uid,
                        url = 'http://dianying.baidu.com/info/cinema/nearby?',
                        param = [
                            'wd=电影院',
                            'lng=' + params.nb_x,
                            'lat=' + params.nb_y,
                            'crt=m',
                            'c=' + params.c,
                            'sfrom=map',
                            'from=webview',
                            'ajax=1',
                            'book_num=3'
                        ].join('&');

                    return BMapCom.Loader.jsonp(url + param)
                        .ok(function(result) {
                            if (result.data && result.data.content && result.data.content.length) {
                                BMapCom.storage.setLocalStorage(storageKey, result.data, 5);
                                self.onSourceLoadFinish(result.data);
                            }
                        })
                        .error(function() {
                            self.onSourceLoadFailed();
                        });
                }
            })
            .delegate({
                onSourceLoadFinish: function(result) {
                    for (var i = 0, len = result.content.length; i < len; i++) {
                        var item = result.content[i],
                            dis = item.dis;

                        if (dis > 0 && dis < 1000) {
                            item.dis_text = dis + 'm';
                        } else if (dis >= 1000 && dis < 10000) {
                            item.dis_text = (dis / 1000 + '').substr(0, 3) + 'km';
                        } else {
                            item.dis_text = '大于10km';
                        }
                    }
                    //地图订单转化统计
                    // pageParamCache.ldata = ldata?ldata:""; 
                    // pageParamCache.qid = qid?qid:"";
                    
                    $('#nearby-cinema').innerHTML = detailTpl.nearby(result);
                },
                startSourceLoad: function(params) {
                    this.search(params);
                }
            });
        nearbyDC.update(params);
    }
    //头部
    var renderPage = function(detailPage, detailTpl, detailData) {
        var bindData = fixBindData(detailData);
        var detail = detailData.content;

        var fixedDetailData = fixData(detailData.content);
        // 渲染基本信息模板

        $('#detailPanel').innerHTML = detailTpl.panel(fixedDetailData);

        //再次请求，并填入距离信息
        //计算当前到影院poi距离

        BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, function(loc) {
             BMapCom.Loader.script('lib/Distance.js')
                            .ok(function() {
                                var distance = Distance.getDistanceByMC({
                                        lat: loc.locY,
                                        lng: loc.locX
                                    }, {
                                        lat: parseInt(fixedDetailData.point.y),
                                        lng: parseInt(fixedDetailData.point.x)
                                    });
                                distance = distance > 1000 ? (distance / 1000).toFixed(1) + "km" : distance.toFixed(0) + "m";
                                $("#distance-text").innerHTML = "距您" + distance;
                            })
                            .error(function() { 
                            });
            
        });
        // 渲染全景icon
        if (fixedDetailData.vista == "1") {
            var dispatcher = new BMapCom.EventDispatcher();
            var evt = new BMapCom.EventDelegater($('#streetscapeDom'));
            evt.on('streetscape:tap', function(e) {
                dispatcher.fire('streetscapeClick', []);
            });
            //点击查看全景
            dispatcher.on('streetscapeClick', function() {
                if (isMonkeyTest) {
                    return;
                }

                var requestParam = {
                    "category": "streetscape",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "street_scape_page",
                        "base_params": {
                            "uid": bindData.uid,
                            "poi_name": bindData.poiName,
                            "poi_type": 'movie',
                            "pt_x": parseInt(bindData.pointX),
                            "pt_y": parseInt(bindData.pointY),
                            "indoor_pano": pageParamCache.indoorScape,
                            "from_source": "poi"
                        }
                    }
                };

                BMapCom.Stat.sendOnline({
                    "da_src": "poidetailpg.streetscapebt",
                    "da_trd": "movie",
                    "da_act": "click",
                    "da_model": "plugin_movie"
                });
                BMapCom.Kernel.notify('request', requestParam, function(result) {});
            });
        }
        // 渲染comment组件
        var fixedCommentData = fixCommentData(detail);
        setTimeout(function() {
            if(fixedCommentData.comments.length == 0){
                $("#commentTab").className = "hide";
                //取消 详情tab点击事件
                $("#scheduleTab").setAttribute("data-ek","");
            }
        }, 200);
        
        if (fixedCommentData && fixedCommentData.comments && fixedCommentData.comments.length) {
            BMapCom.Plugin.use('!./plugin/CommentView/CommentView').then(function(CommentView) {
                //tab显示评论数目
                var commentNum = fixedCommentData.total,
                    numText = "";
                if(commentNum && commentNum > 0 && commentNum <= 999){
                    numText =  "(" + commentNum + ")";
                }
                if(commentNum && commentNum > 999){
                    numText =  "(" + commentNum + "+)";
                }
                $("#commentNum").innerHTML = numText;
                var commentView = CommentView.instantiate(fixedCommentData, $('#detailComment'));
                commentView.event.on('seeMoreClick', function() {
                    var entranceParam = {
                        "page": "moreCommentPage",
                        "pageParam": {
                            //必传参数
                            "uid": bindData.uid,
                            "poiName": bindData.poiName
                        }
                    }
                    BMapCom.Stat.sendOnline({
                        "da_src": "poidetailpg.morecommentbt",
                        "da_trd": "movie",
                        "da_act": "click",
                        "da_model": "plugin_movie"
                    });
                    BMapCom.Kernel.notify('changePage', entranceParam);
                });
            });
        }

        // 无影讯影院加载附近推荐影院
        if (detailData.content && detailData.content.ext && detailData.content.ext.other_info) {
            var otherInfo = detailData.content.ext.other_info,
                detailInfo = detailData.content.ext.detail_info;
            if (!otherInfo.time_table || !otherInfo.time_table.length) {
                loadNearbyCinema(detailTpl, {
                    uid: detailData.content.uid,
                    nb_x: detailInfo.point.x,
                    nb_y: detailInfo.point.y,
                    c: detailData.content.city_id
                });
            }
        }

        //初始化Widget
        var widgetParam = {
            "uid": bindData.uid,
            "poi_name": bindData.poiName,
            "poi_addr": bindData.address,
            "poi_tel": bindData.tel,
            //PoiType:0为普通点
            "poi_type": 0,
            "pt_x": parseInt(bindData.pointX),
            "pt_y": parseInt(bindData.pointY),
            "city_id": bindData.cityId,
            "deep_detail": {
                "src_name": "scope",
                "overall_rating": bindData.rating,
                "image": bindData.imageUrl,
                "price": bindData.price,
                "tag": bindData.tag,
                "premium_flag": bindData.premiumFlag,
                "comment_num": bindData.commentNum
            }
        };
        if (pageParamCache.option && pageParamCache.option.index) {
            widgetParam.index = pageParamCache.option.index;
        }
        //Header
        BMapCom.Kernel.notify('widget', {
            "wid": "poi_detail_header",
            "method": "init",
            "param": widgetParam
        });
        //Footer
        BMapCom.Kernel.notify('widget', {
            "wid": "poi_detail_footer",
            "method": "init",
            "param": widgetParam
        });
    }
    //影院排期
    var renderMoviePage = function(detailPage, detailTpl, detailData) {
        if (!detailData || !detailData.time_table || detailData.time_table.length < 1) {
            $('#loadMovie').style.display = 'none';
            return;
        }
        BMapCom.Plugin.use('!./plugin/MovieBookView/MovieBookView').then(function(MovieBookView) {
            MovieBookView.instantiate(detailData, $('#detailMovieBook'), pageParamCache);

           
            //判断imax 3d 可选座卡片
            var detailBase = detailData.base,
                is_imax = false,
                is_select = false;
            for (var i = detailBase.length - 1; i >= 0; i--) {
                if (detailBase[i].is_imax == "1") {
                    is_imax = true;
                };
            };
            if (detailData.time_table.length > 0) {
                var timetable = detailData.time_table;
                for (var i = timetable.length - 1; i >= 0; i--) {
                    if(timetable[i] && timetable[i][0] && timetable[i][0].lower_price && timetable[i][0].lower_price > 0 && timetable[i].length > 0){
                        is_select = true;
                    }
                };
            }

            if (is_imax) {
                $("#isimax").className = "panel-other-text"; 
            }
            if (is_select) {
                $("#isselect").className = "panel-other-text";
            };
        });
    }
    //团购
    var renderGrouponPage = function(detailPage, detailTpl, detailData) {
        if (detailData && detailData.groupon && detailData.groupon.length) {
            BMapCom.Plugin.use('!./plugin/SaleView/SaleView').then(function(GrouponView) {
                var grouponView = GrouponView.instantiate(detailData, $('#detailTuan'));
                grouponView.on('grouponClick', function(grouponid) {
                    if (isMonkeyTest) {
                        return;
                    }
                    var is_cinema_location_exist = pointCurrent.pointX && pointCurrent.pointY?1:0,
                        tuan_lat = pointCurrent.pointY,
                        tuan_lng = pointCurrent.pointX,
                        entranceParam = {
                            category: "groupon",
                            method:  BMapCom.ComRequestMethod.DISPATCH,
                            param: {
                                "target": "target_groupon_detail",
                                "base_params": {
                                    "key_detail_dealid": grouponid,
                                    "src_channel": "map_movie",
                                    "is_cinema_location_exist": is_cinema_location_exist,
                                    "tuan_lat": tuan_lat,
                                    "tuan_lng": tuan_lng,
                                    "ldata": pageParamCache.ldata?pageParamCache.ldata:"",
                                    "qid": pageParamCache.qid?pageParamCache.qid:""
                                }
                            }
                        };
                    BMapCom.Stat.sendOnline({
                        "da_src": "poidetailpg.tuanitembt",
                        "da_act": "click",
                        "da_model": "plugin_movie",
                        "da_trd": "movie"
                    });
                    BMapCom.Kernel.notify('request', entranceParam);
                });

                grouponView.on('moregrouponClick', function(url) {
                    if (isMonkeyTest) {
                        return;
                    }

                    BMapCom.Stat.sendOnline({
                        "da_src": "poidetailpg.tuanmorebt",
                        "da_act": "click",
                        "da_model": "plugin_movie",
                        "da_trd": "movie"
                    });

                    var $saleContainer = $(".sale-container").children,
                        $displayDiv = new Array(),
                        $moregroupon = $(".moreGroupon");

                    if ($moregroupon.getAttribute("data-tag") == "0") {
                        for (var m = 0, dlength = $saleContainer.length; m < dlength; m++) {
                            if ($saleContainer[m].className != "moreGroupon" && $saleContainer[m].getAttribute("data-hide") == "hide") {
                                $saleContainer[m].className = "sale-item";
                                $saleContainer[m].setAttribute("data-hide", "");
                            }
                        }
                        $moregroupon.children[0].innerHTML = "收起";
                        $moregroupon.children[1].className = "moreGroupon-icon-up";
                        $moregroupon.setAttribute("data-tag", "1");
                    } else {
                        for (var n = 0, dlength = $saleContainer.length; n < dlength; n++) {
                            if ($saleContainer[n].className != "moreGroupon" && n > 0) {
                                $saleContainer[n].className = "sale-item hide";
                                $saleContainer[n].setAttribute("data-hide", "hide");
                            }
                        }
                        $moregroupon.children[0].innerHTML = "更多" + $moregroupon.children[0].getAttribute('data-grounnum') + "个团购";
                        $moregroupon.children[1].className = "moreGroupon-icon";
                        $moregroupon.setAttribute("data-tag", "0");
                    }

                });
            });
        }
    }

    /*页面事件注册
    */
    var bindPageEvent = function(detailData) {
        var bindData = fixBindData(detailData),
            evt = new BMapCom.EventDelegater($('#detailContainer'));

        evt.on('nearbyBtn:tap', function(e) {
            if (isMonkeyTest) {
                return;
            }
            var requestParam = {
                "category": "mainmap",
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "nearby_page",
                    "base_params": {
                        "poi_name": bindData.poiName,
                        "pt_x": parseInt(bindData.pointX),
                        "pt_y": parseInt(bindData.pointY)
                    }
                }
            };

            BMapCom.Stat.sendOnline({
                "da_src": "poidetailpg.searchnbbt",
                "da_trd": "movie",
                "da_act": "click",
                "da_model": "plugin_movie"
            });

            BMapCom.Kernel.notify('request', requestParam);
        });

        //地址卡片-到这去
        evt.on('gotoBtn:tap', function(e) {

            if (isMonkeyTest) {
                return;
            }
            BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID], function(runtimeInfo) {
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "route_search_page",
                        "base_params": {
                            "start_type": 1,
                            "start_keyword": "我的位置",
                            "start_longitude": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locX,
                            "start_latitude": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locY,
                            "start_city_id": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID],
                            "end_type": 1,
                            "end_keyword": bindData.poiName,
                            "end_longitude": parseInt(bindData.pointX),
                            "end_latitude": parseInt(bindData.pointY),
                            "end_uid": pageParamCache.uid,
                            "end_city_id": bindData.cityId
                        }
                    }
                };

                BMapCom.Stat.sendOnline({
                    "da_src": "poidetailpg.gotherebt",
                    "da_trd": "movie",
                    "da_act": "click",
                    "da_model": "plugin_movie"
                });
                
                BMapCom.Kernel.notify('request', requestParam);
            });
        });
        evt.on('telBtn:tap', function(e) {
            if (isMonkeyTest) {
                return;
            }
            var phoneNum = this.getAttribute('data-value');

            BMapCom.Stat.sendOnline({
                "da_src": "poidetailpg.callupbt",
                "da_trd": "movie",
                "da_act": "click",
                "da_model": "plugin_movie"
            });

            BMapCom.SysApi.tel(phoneNum);
        });

        evt.on('gotoTel:tap', function(e) {
            if (isMonkeyTest) {
                return;
            }
            var phoneNum = this.getAttribute('data-value');

            BMapCom.Stat.sendOnline({
                "da_src": "poidetailpg.callservicesbt",
                "da_trd": "movie",
                "da_act": "click",
                "da_model": "plugin_movie"
            });

            BMapCom.SysApi.tel(phoneNum);
        });

        evt.on('gotoOrder:tap', function(e) {
            if (isMonkeyTest) {
                return;
            }
            var requestParam = {
                "category": "movie",
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "order_page"
                }
            };

            BMapCom.Stat.sendOnline({
                "da_src": "poidetailpg.ordercerterbt",
                "da_trd": "movie",
                "da_act": "click",
                "da_model": "plugin_movie"
            });

            BMapCom.Kernel.notify('request', requestParam);
        });

        evt.on('gotoDetail:tap', function(e) {
            var cinemaid = this.getAttribute("data-uid"),
                movie_id = pageParamCache.movie_id,
                url_param = {
                    "page": "cinemaDetailPage",
                    "pageParam": {
                        'uid': cinemaid,
                        'movie_id': movie_id,
                        'ldata': pageParamCache.ldata?pageParamCache.ldata:"",
                        'qid': pageParamCache.qid?pageParamCache.qid:""
                    }
                };

            BMapCom.Stat.sendOnline({
                "da_src": "poidetailpg.nearbybt",
                "da_trd": "movie",
                "da_act": "click",
                "da_model": "plugin_movie"
            });

            BMapCom.Kernel.notify('changePage', url_param);
        });

        evt.on('zhidahaoBtn:tap', function(e) {
            if (isMonkeyTest) {
                return;
            }
            var entranceParam = {
                "page": "defaultWebViewPage",
                "pageParam": {
                    "url": this.getAttribute('data-url')
                }
            }

            BMapCom.Kernel.notify('changePage', entranceParam);
        });
        
        //地址卡片-地图跳转
        evt.on('gotomapBtn:tap', function(e) {
            if (isMonkeyTest) {
                return;
            }
            var entranceParam = {
                "page": "mainMap",
                "pageParam": {
                   
                }
            }
            BMapCom.Kernel.notify('changePage', entranceParam);
        });

        var $scheduleTabTarget = $("#scheduleTab-target"),
            $streetCard = $("#streetCard"),
            $commentTab = $("#commentTab"),
            $scheduleTab = $("#scheduleTab"),
            $detailComment = $("#detailComment");
        evt.on('commentTab:tap', function(e) {
            $scheduleTabTarget.style.display="none";
            $streetCard.style.display="none";
            $detailComment.style.display="";
            $commentTab.className="tab-select";
            $scheduleTab.className="";
            // $commentTab.c
        });
        evt.on('scheduleTab:tap', function(e) {
            $scheduleTabTarget.style.display="";
            $streetCard.style.display="";
            $detailComment.style.display="none";
            $commentTab.className=""
            $scheduleTab.className="tab-select";
        });

    }

    var initMethod = function(detailPage, detailTpl) {
        // 移除外层container的overflow,引起iscroll的渲染bug
        detailPage.pageBody.style.overflow = '';

        /*绑定数据对象代理
        */
        //头部poi
        var poiDetailSource = new BMapCom.DataSource();
        poiDetailSource
            .delegate(poiDetailSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    renderPage(detailPage, detailTpl, result);
                    bindPageEvent(result);
                },
                startSourceLoad: function(uid) {
                    this.search(uid);
                }
            });

        var movieDetailSource = new BMapCom.DataSource();
        //影讯
        movieDetailSource
            .delegate(movieDetailSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    renderMoviePage(detailPage, detailTpl, result);
                },
                startSourceLoad: function(uid) {
                    this.search(uid);
                }
            });

        var grouponDetailSource = new BMapCom.DataSource();
        //团购
        grouponDetailSource
            .delegate(grouponDetailSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    renderGrouponPage(detailPage, detailTpl, result);
                },
                startSourceLoad: function(uid) {
                    this.search(uid);
                }
            });

        //绑定页面事件代理
        detailPage
            .delegate({
                shouldWaiting: function() {
                    return true;
                },
                onCreate: function(pageParam, ready) {
 
                    pageParamCache = pageParam;

                    BMapCom.Stat.sendOnline({
                        "da_src": "poidetailpg",
                        "da_trd": "movie",
                        "da_model": "plugin_movie",
                        "da_act": "show"
                    });

                    detailPage.append(detailTpl.body({}));
                    $('#loadMovie').style.display = 'block';
                    if (BMapCom.util.platform.isAndroid()) {
                        $('#footer-space').className = 'footer-space';
                    }

                    BMapCom.Plugin.use('!./plugin/MovieBookView/MovieBookView');
                    var promise = new BMapCom.Promise(function(fulfill, reject) {
                        BMapCom.Loader.script('lib/iScroll.js')
                            .ok(function() {
                                fulfill();
                            })
                            .error(function() {
                                reject({});
                            })
                    });
                    promise.then(function() {
                        movieDetailSource.update(pageParam.uid);
                    });

                    // 开始请求详情数据
                    poiDetailSource.update(pageParam.uid);
                    grouponDetailSource.update(pageParam.uid);
                    BMapCom.Kernel.notify('webPageReady');
                },
                onDestory: function() {}
            });
    }

    // 入口
    return {
        initWithPage: initMethod
    }
});