BMapCom.Controller.create(function() {
    var isMonkeyTest = BMapCom.config('isMonkeyTest');

    var globalData = {};

    function $ (q) {
        return document.querySelector(q);
    }

    function hasClass(elem, cls) {
        return elem.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
    }

    function addClass(elem, cls) {
        if (!hasClass(elem, cls)) {
            elem.className += ' ' + cls;
        }
    }

    function removeClass(elem, cls) {
        var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
        if (hasClass(elem, cls)) {
            elem.className = elem.className.replace(reg, '');
        }
    }

    function jsonToUrl (obj) {
        var strArr = [],
            key;

        for(key in obj) {
            if (obj.hasOwnProperty(key)) {
                strArr.push(key + '=' + obj[key]);
            }
        }

        return strArr.join('&');
    }

    function getDateArr (nowDateStr) {
        var timeArr = nowDateStr.split('-'),
            today = new Date(timeArr[0], timeArr[1] - 1, timeArr[2]),
            month,
            day;

        month = today.getMonth() + 1;
        month = month > 9 ? month : '0' + month;

        day = today.getDate();
        day = day > 9 ? day : '0' + day;

        return [today.getFullYear(), month, day];
    }

    function parseDate (nowDateStr, onlineDateStr) {
        var formatDate = {},
            //dateArr = getDateArr(onlineDateStr),
            newDate = new Date(onlineDateStr),
            nowDate = new Date(nowDateStr),
            weeks = ['周日','周一','周二','周三','周四','周五','周六'];

        formatDate.month = newDate.getMonth() + 1;
        formatDate.day = newDate.getDate();
        formatDate.label = weeks[newDate.getDay()];

        switch ((newDate - nowDate) / 86400000) {
            case 0:
                formatDate.label = '今天';
                break;
            case 1:
                formatDate.label = '明天';
                break;
            case 2:
                formatDate.label = '后天';
                break;
            default :
                break;
        }

        return formatDate;
    }

    var dataFixer = {
        fixScheData: function(data, uid, isFrequent) {
            var timeTable = data.time_table,
                nowDate = data.now_time,
                scheItem,
                timeItem,
                day,
                time,
                bdMpStaData = "",
                ldata = globalData.pageParam.ldata?globalData.pageParam.ldata + "|":"",
                qid = globalData.pageParam.qid?globalData.pageParam.qid + "|":"";
            // 地图订单统计需求
            bdMpStaData = encodeURIComponent(ldata + qid + 'resid=01');

            data.time_obj = [];
            data.uid = uid;
            for(day = 0; day < timeTable.length; day++) {
                scheItem = timeTable[day];
                if (!scheItem.length) {
                    continue;
                }
                data.time_obj.push(parseDate(nowDate, scheItem[0].date));
                for(time = 0; time < scheItem.length; time++){
                    timeItem = scheItem[time];
                    timeItem['book_url'] = render.domain + '/detail?qt=movie&act=select&from=webview' + '&seq_no=' + timeItem.src_info[0].seq_no  + '&cinema_id=' + timeItem.src_info[0].cinema_id + '&third_from=' + timeItem.src_info[0].src + '&date=' + timeItem.date + 
                                        '&movie_id=' + timeItem.movie_id + '&sfrom=map&wallet_sdk=1' + '&sub_channel=' + bdMpStaData;
                    timeItem['is_frequent'] = isFrequent
                }
            }
            return data;
        },
        fixCinemaData: function(data) {
            var item,
                dis,
                len,
                i;

            // 对距离的处理
            for(i = 0, len = data.content.length; i < len; i++) {
                item = data.content[i];
                dis = item.dis;

                if (dis > 0 && dis < 1000) {
                    item.dis_text = dis + 'm';
                }else if (dis >= 1000 && dis < 10000) {
                    item.dis_text = (dis / 1000 + '').substr(0, 3) + 'km';
                }else{
                    item.dis_text = '大于10km';
                }
            }

            // 当影院都不可预订时显示
            data.tipText = render.tipsText.schedule;

            //地图订单转化统计
            // globalData.pageParam.ldata = ldata?ldata:"";
            // globalData.pageParam.qid = qid?qid:"";

            return data;
        }
    }

    var render = {
        domain: 'http://map.baidu.com',
        dianyingDomain: 'http://dianying.baidu.com',
        testDomain: 'http://cp01-rdqa-pool392.cp01.baidu.com:8081',
        tipsText: {
            'search': '未检索到附近相关影院',
            'cinema': '影院加载失败，请刷新重试~',
            'schedule': '影片已无场次，下次早点来哟~'
        },

        renderLoading: function() {
            $('.list-info').innerHTML = globalData.tpl.loading();
            this.changeLoadStatus('hide');
        },
        renderCinemaList: function(data) {
            var self = this,
                tpl = globalData.tpl,
                wrapper = $('.list-info'),
                fixData = dataFixer.fixCinemaData(data),
                html = tpl.schedule(fixData),
                type = globalData.pageParam.type,
                isShowMore = (10 * (globalData.pageParam.pn + 1)) < fixData.result.total;

            switch (type) {
                case 'default':
                    wrapper.innerHTML = html;
                    self.changeLoadStatus(isShowMore ? 'show' : 'hide');
                    break;
                case 'search':
                    wrapper.innerHTML = html;
                    self.changeLoadStatus('hide');
                    break;
                case 'more':
                    wrapper.innerHTML += html;
                    self.changeLoadStatus(isShowMore ? 'load' : 'hide');
                    break;
                case 'cancel':
                    wrapper.innerHTML = html;
                    $('.search-ipt').value = '';
                    self.changeLoadStatus(isShowMore ? 'show' : 'hide');
                    break;
            }
        },

        renderFailed: function(type, container) {
            var self = this,
                tpl = globalData.tpl,
                html,
                arrowIcon;

            if (type == 'search') {
                container = $('.list-info')
                html = tpl.schedule({
                    noData: true,
                    tipText: self.tipsText['search']
                });
            } else if (type == 'cinema') {
                container = $('.list-info')
                html = tpl.schedule({
                    noData: true,
                    tipText: self.tipsText['cinema']
                });
            } else {
                arrowIcon = container.parentElement.children[1].children[3];
                removeClass(arrowIcon, 'arrow-loading');
                addClass(arrowIcon, 'arrow-up');
                html = tpl.timetable({
                    noData: true,
                    tipText: self.tipsText['schedule']
                });
            }

            container.innerHTML = html;
            self.changeLoadStatus('hide');
        },
        renderScheList: function(data, uid, container, isFrequent) {
            var tpl = globalData.tpl,
                fixData = dataFixer.fixScheData(data, uid, isFrequent),
                arrowIcon = container.parentElement.children[1].children[3];

            removeClass(arrowIcon, 'arrow-loading');
            addClass(arrowIcon, 'arrow-up');
            container.innerHTML = tpl.timetable(fixData);
        },
        changeLoadStatus: function(type) {
            var loadBtn = $('.load-more'),
                loadIcon = $('.load-more .load-icon'),
                loadText = $('.load-more .load-text');

            switch (type) {
                case 'loading':    // 加载中
                    loadBtn.style.display = 'block';
                    loadIcon.className = 'load-icon load-icon-loading';
                    loadText.innerHTML = '加载中...';
                    break;
                case 'load':
                    loadBtn.style.display = 'block';
                    loadIcon.className = 'load-icon';
                    loadText.innerHTML = '加载更多';
                    break;
                case 'hide':
                    loadBtn.style.display = 'none';
                    loadIcon.className = 'load-icon';
                    loadText.innerHTML = '加载更多';
                    break;
                case 'show':
                    loadBtn.style.display = 'block';
                    break;
            }
        }
    }
    var filmSchedule = {
        initWithPage: function(filmSchePage, filmScheTpl) {
            var self = this;

            // overflow:auto引起的bug
            filmSchePage.pageBody.style.overflow = '';

            filmSchePage
                .delegate({
                    shouldWaiting: function() {
                        return true;
                    },
                    onCreate: function(pageParam, ready) {
                        globalData.pageParam = pageParam;
                        globalData.page = filmSchePage;
                        globalData.tpl = filmScheTpl;

                        // 渲染空模板
                        filmSchePage.append(filmScheTpl.body());

                        BMapCom.Stat.sendOnline({
                            "da_src" : "selectcinemapg",
                            "da_trd" : "movie",
                            "da_model" : "plugin_movie",
                            "da_act": "show"
                        });

                        self.bindPageEvent();

                        // 首次加载全部渲染影院列表
                        globalData.pageParam.pn = 0;
                        globalData.pageParam.type = 'default';
                        render.renderLoading();
                        self.getCinemaList();
                        BMapCom.Kernel.notify('webPageReady');
                    },
                    onDestory: function() {}
                });
        },
        bindPageEvent: function() {
            var self = this,
                delEvent = new BMapCom.EventDelegater($('.list-info')),
                loadEvent = new BMapCom.EventDelegater($('.load-more')),
                serviceEvent = new BMapCom.EventDelegater($('#fs-service')),
                scheWrapper,
                arrowIcon,
                item,
                uid;

            function collapseAllItem() {
                var allItems = document.querySelectorAll('.list-info .list-timetable');

                for (var i = 0, len = allItems.length; i < len; i++ ) {
                    item = allItems[i];
                    item.style.display = 'none';
                    removeClass(item.previousElementSibling.children[3], 'arrow-up');
                }
            }

            $('.sche-act').addEventListener('click', function() {
                var entranceParam = {
                    "page": "defaultWebViewPage",
                    "pageParam": {
                        "url": this.getAttribute('data-url')
                    }
                }

                BMapCom.Stat.sendOnline({
                    "da_src" : "selectcinemapg.bannerbt",
                    "da_trd" : "movie",
                    "da_model" : "plugin_movie",
                    "da_act": "click"
                });

                BMapCom.Kernel.notify('changePage', entranceParam);
            });

            // 点击影院 获取排期list
            delEvent.on('getSchedule:tap', function(e) {
                uid = this.getAttribute('data-uid');

                if (uid) {
                    scheWrapper = this.nextElementSibling;
                    arrowIcon = this.children[3];
                    // 展开购票列表   
                    if (scheWrapper.style.display == 'none') {
                        var isFrequent = (this.getAttribute('data-frequent') == 'true'),
                            statSrc = isFrequent ? 'nearbycinemafrequentbt' : 'nearbycinemabt';

                        // 先收起所有列表
                        collapseAllItem();

                        window.scrollTo(0, this.offsetParent.offsetTop);

                        BMapCom.Stat.sendOnline({
                            "da_src" : "selectcinemapg." + statSrc,
                            "da_trd" : "movie",
                            "da_model" : "plugin_movie",
                            "da_act": "click"
                        });

                        scheWrapper.style.display = 'block';
                        // // 重新获取购票信息
                        if (!scheWrapper.children.length) {
                            addClass(arrowIcon, 'arrow-loading');
                            self.getScheduleList(uid, scheWrapper, isFrequent);
                        }else{
                            addClass(arrowIcon, 'arrow-up');
                        }
                        
                    // 收起购票列表
                    }else {
                        removeClass(arrowIcon, 'arrow-up');
                        scheWrapper.style.display = 'none';
                        removeClass(this, "trangle");
                    }
                }
            });

            //查看影院详情 BY shdong 140902 16:47
            delEvent.on('cinemaDetail:tap', function(e) {
                var cinemaid = this.getAttribute("data-cinemaid"),
                    movie_id = this.getAttribute("data-movieid"),
                    url_param = {
                        "page": "cinemaDetailPage",
                        "pageParam": {
                            'uid': cinemaid,
                            'movie_id': movie_id,
                            'ldata': globalData.pageParam.ldata?globalData.pageParam.ldata:"",
                            'qid': globalData.pageParam.qid?globalData.pageParam.qid:""
                        }
                    };

                BMapCom.Stat.sendOnline({
                    "da_src" : "selectcinemapg.cinemadetailbt",
                    "da_trd" : "movie",
                    "da_model" : "plugin_movie",
                    "da_act": "click"
                });

                BMapCom.Kernel.notify('changePage', url_param);
            }); 

            // 购票
            delEvent.on('movieBookBtn:tap', function(e) {
               /*
                if (isMonkeyTest) {
                    return;
                }
                */

                self.buyTicket(this.getAttribute('data-url'),
                    this.getAttribute('data-from'), this.parentNode.getAttribute('data-uid'), this.getAttribute('data-frequent'));
            });

            // 查看更多影院
            loadEvent.on('loadMore:tap', function(e) {
                globalData.pageParam.type = 'more';
                globalData.pageParam.pn++;

                BMapCom.Stat.sendOnline({
                    "da_src" : "selectcinemapg.morecinemasbt",
                    "da_trd" : "movie",
                    "da_model" : "plugin_movie",
                    "da_act": "click"
                });

                render.changeLoadStatus('loading');
                self.getCinemaList();
            });

            // 查看订单
            serviceEvent.on('gotoOrder:tap', function(e) {
                if (isMonkeyTest) {
                    return;
                }
                var requestParam = {
                    "category": "movie",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "order_page"
                    }
                };

                BMapCom.Stat.sendOnline({
                    "da_src" : "selectcinemapg.ordercenterbt",
                    "da_trd" : "movie",
                    "da_model" : "plugin_movie",
                    "da_act": "click"
                });

                BMapCom.Kernel.notify('request', requestParam);
            });

            // 客服电话
            serviceEvent.on('gotoTel:tap', function() {
                if (isMonkeyTest) {
                    return;
                }

                BMapCom.Stat.sendOnline({
                    "da_src" : "selectcinemapg.custoncallbt",
                    "da_trd" : "movie",
                    "da_model" : "plugin_movie",
                    "da_act": "click"
                });
                BMapCom.SysApi.tel(this.getAttribute('data-value'));
            });

            // 搜索提交
            $('.search-iptwrapper').addEventListener('submit', function(e) {
                e.preventDefault();
                self.submitForm();
            });

            // 搜索框input事件
            $('.search-ipt').addEventListener('input', function(e) {
                self.showQuickDel();

                // 输入框默认清空时获取默认列表
                !$('.search-ipt').value && self.getDefaultList();
            });

            // 快速删除按钮
            $('.search-del').addEventListener('click', function(e) {
                $('.search-ipt').value = '';
                self.getDefaultList();
            });

            // 取消按钮
            $('.search-btn').addEventListener('click', function(e) {
                self.submitForm();
            });

            // 获得焦点，判断是否显示快速删除按钮
            $('.search-ipt').addEventListener('focus', function(e) {
                self.showQuickDel();
            });
        },
        getDefaultList: function() {
            globalData.pageParam.type = 'cancel';
            globalData.pageParam.pn = 0;
            this.getCinemaList();
        },
        buyTicket: function(bookUrl, from, uid, frequent) {
            var entranceParam = "",
                validates = {
                    'wanda': 1
                },
                isAndroid = BMapCom.util.platform.isAndroid(),
                splits;

            BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, function(bduss) {
                if (bduss) {
                    var fre_params = {
                            uid: uid,
                            key: bduss,
                            from: "webview",
                            sfrom: "map",
                            token: "d5323c6e3ad4eb25aabf776113d1ce1c",
                            action: "set"
                        },
                        requestImage = new Image();

                    requestImage.src = render.domain + '/movie/info/lightapp/history?' + jsonToUrl(fre_params);
                }
            });

            if(validates[from]){
                splits = bookUrl.match(/seq_no=([^&]*)&cinema_id=([^&]*)&third_from=([^&]*)&date=([^&]*)&movie_id=([^&]*)/);

                BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, function(bduss) {
                    entranceParam = {
                        "page": "movieValidatePage",
                        "pageParam": {
                            "uid": uid,
                            "bduss": bduss,
                            "seq_no": splits[1],
                            "cinema_id": splits[2],
                            "third_from": splits[3],
                            "date": splits[4],
                            "movie_id": splits[5],
                            "sfrom": 'map',
                            "from": 'webview'
                        }
                    };
                    BMapCom.Kernel.notify('changePage', entranceParam);
                });
            }else{
                // android需要调用基线的webview，走通调用钱包sdk流程
                if (isAndroid) {
                    var requestParam = {
                        "category": "mainmap",
                        "method": BMapCom.ComRequestMethod.DISPATCH,
                        "param": {
                            "target": "web_shell_page",
                            "base_params": {
                                'webview_url': bookUrl,
                                'webshell_is_share_show': false
                            }
                        }
                    };

                    BMapCom.Kernel.notify('request', requestParam);
                }else {
                    var entranceParam = {
                        "page": "defaultWebViewPage",
                        "pageParam": {
                            "url": bookUrl
                        }
                    }
                    BMapCom.Kernel.notify('changePage', entranceParam);
                }
            }

            BMapCom.Stat.sendOnline({
                "da_src" : "selectcinemapg." + (frequent ? "buyticketfrequentbt" : "buyticketbt"),
                "da_trd" : "movie",
                "da_model" : "plugin_movie",
                "da_act": "click"
            });
        },
        showQuickDel: function(type) {
            var quickDel = $('.search-del');

            if (type == 'show') {
                quickDel.style.visibility = 'visible';
            } else if(type == 'hide') {
                quickDel.style.visibility = 'hidden';
            } else{
                quickDel.style.visibility = $('.search-ipt').value ? 'visible' : 'hidden';
            }
        },
        submitForm: function() {
            var self = this,
                wd = $('.search-ipt').value;

            if (wd) {
                render.renderLoading();

                globalData.pageParam.pn = 0;
                globalData.pageParam.type = 'search';
                globalData.pageParam.wd = wd;

                BMapCom.Stat.sendOnline({
                    "da_src" : "selectcinemapg.seachframe",
                    "da_trd" : "movie",
                    "da_model" : "plugin_movie",
                    "da_act": "click"
                });

                $('.search-ipt').blur();
                window.scrollTo(0, 0);
                self.searchCinemaList();
            }
        },
        searchCinemaList: function() {
            var self = this,
                params = globalData.pageParam,
                sCinemaListSource = new BMapCom.DataSource(),
                urlParams = {
                    qt: 's',
                    pl_data_type: 'life',
                    pl_business_type: 'life',
                    pl_sub_type: '电影院',
                    pl_movie_book_section: encodeURIComponent('1,+'),
                    ie: 'utf-8',
                    c: params.c,
                    wd: params.wd || params.movie_name,
                    pn: params.pn,
                    rn: 100,
                    nb_x: params.nb_x ? params.nb_x : 1,
                    nb_y: params.nb_y ? params.nb_y : 1,
                    movie_name: params.movie_name,
                    movie_id: params.movie_id,
                    req_from: 'app',
                    interface_direct_tag: 1,
                    from: 'webview',
                    sfrom: 'map'
                }

            sCinemaListSource
                .delegate({
                    search: function() {
                        self.getData({
                            url: render.domain + "/movie/info/api/search/?" + jsonToUrl(urlParams),
                            dataSource: sCinemaListSource,
                            dataType: 'scinema'
                        });
                    }
                })
                .delegate({
                    onSourceLoadFinish: function(result) {
                        render.renderCinemaList(result);
                    },
                    startSourceLoad: function(opts) {
                        this.search(opts);
                    },
                    onSourceLoadFailed: function() {
                        render.renderFailed('search');
                    }
                });

            sCinemaListSource.update(params.movie_id);
        },
        getCinemaList: function() {
            var self = this,
                params = globalData.pageParam,
                cinemaListSource = new BMapCom.DataSource(),
                urlParams = {
                    qt: 's',
                    pl_data_type: 'life',
                    pl_business_type: 'life',
                    pl_sub_type: '电影院',
                    pl_movie_book_section: encodeURIComponent('1,+'),
                    ie: 'utf-8',
                    c: params.c,
                    wd: params.movie_name,
                    pn: params.pn,
                    nb_x: params.nb_x ? params.nb_x : 1,
                    nb_y: params.nb_y ? params.nb_y : 1,
                    movie_id: params.movie_id,
                    req_from: 'app',
                    interface_direct_tag: 1,
                    from: 'webview',
                    sfrom: 'map'
                }
            cinemaListSource
                .delegate({
                    search: function() {
                        self.getData({
                            url: render.domain + "/movie/info/api/suggest/?" + jsonToUrl(urlParams),
                            storageKey: 'lsk-cinema-' + params.movie_id + '-' + params.pn,
                            dataSource: cinemaListSource,
                            dataType: 'gcinema'
                        });
                    }
                })
                .delegate({
                    onSourceLoadFinish: function(result) {
                        render.renderCinemaList(result);
                    },
                    startSourceLoad: function(opts) {
                        this.search(opts);
                    },
                    onSourceLoadFailed: function() {
                        render.renderFailed('cinema');
                    }
                });

            cinemaListSource.update(params.movie_id);
        },
        // 展开影片排期list
        getScheduleList: function(uid, container, isFrequent) {
            var self = this,
                scheListSource = new BMapCom.DataSource(),
                urlParams = {
                    qt: "timetable",
                    uid: uid,
                    from: "webview",
                    sfrom: 'map',
                    movie_id: globalData.pageParam.movie_id
                }

            scheListSource.delegate({search: function() {
                        self.getData({
                            url: render.domain + "/detail?" + jsonToUrl(urlParams),
                            storageKey: 'lsk-sche-' + uid,
                            dataSource: scheListSource,
                            dataType: 'schedule'
                        });
                    }
                }).delegate({
                    onSourceLoadFinish: function(result) {
                        render.renderScheList(result, uid, container, isFrequent);
                    },
                    startSourceLoad: function() {
                        this.search();
                    },
                    onSourceLoadFailed: function() {
                        render.renderFailed('schedule', container);
                    }
                });

            scheListSource.update();
        },
        getData: function(opts) {
            var self = this,
                dataSource = opts.dataSource,
                storageKey = opts.storageKey,
                resultData = BMapCom.storage.getLocalStorage(storageKey);

            if (!opts.url) {
                return null;
            }

            // 命中缓存
            if (resultData) {
                dataSource.onSourceLoadFinish(resultData);
            } else {
                BMapCom.Loader.jsonp(opts.url)
                    .ok(function(result) {
                        switch(opts.dataType) {
                            case 'film':
                                if (result.data && result.data.movie_id) {
                                    BMapCom.storage.setLocalStorage(storageKey, result.data, 5);
                                    dataSource.onSourceLoadFinish(result.data);
                                }
                                break;
                            case 'scinema':
                                if (result.data && result.data.content && result.data.content.length) {
                                    dataSource.onSourceLoadFinish(result.data);
                                }else {
                                    dataSource.onSourceLoadFailed();
                                }
                                break;
                            case 'gcinema':
                                if (result.data && result.data.content && result.data.content.length) {
                                    BMapCom.storage.setLocalStorage(storageKey, result.data, 5);
                                    dataSource.onSourceLoadFinish(result.data);
                                }else {
                                    dataSource.onSourceLoadFailed();
                                }
                                break;
                            case 'schedule':
                                if (result.data && result.data.time_table && result.data.time_table.length) {
                                    dataSource.onSourceLoadFinish(result.data);
                                }else {
                                    dataSource.onSourceLoadFailed();
                                }
                                break;
                            default:
                                break;

                        }
                    })
                    .error(function() {
                        dataSource.onSourceLoadFailed();
                    });
            }
        }
    }

    return filmSchedule
});