BMapCom.Controller.create(function() {

    var globalData = {};

    function $ (q) {
        return document.querySelector(q);
    }

    function jsonToUrl (obj) {
        var strArr = [],
            key;

        for(key in obj) {
            if (obj.hasOwnProperty(key)) {
                strArr.push(key + '=' + obj[key]);
            }
        }

        return strArr.join('&');
    }

    var movieTicket = {
        initWithPage: function(movieTicketPage, movieTicketTpl) {
            var self = this;

            // overflow:auto引起的bug
            movieTicketPage.pageBody.style.overflow = '';

            movieTicketPage
                .delegate({
                    shouldWaiting: function() {
                        return true;
                    },

                    onCreate: function(pageParam, ready) {
                        var promise;

                        globalData.pageParam = pageParam;
                        globalData.page = movieTicketPage;
                        globalData.tpl = movieTicketTpl;

                        // 渲染空模板
                        movieTicketPage.append(movieTicketTpl.body());

                        // 提前加载比价区预订资源
                        BMapCom.Plugin.use('!./plugin/MovieBookView/MovieBookView');

                        new BMapCom.Promise(function(fulfill, reject) {
                            BMapCom.Loader.script('lib/iScroll.js')
                                .ok(function() {
                                    fulfill();
                                })
                                .error(function() {
                                    reject({});
                                })
                        }).then(function() {
                            self.getScheduleData()
                                .then(function(data) {
                                    BMapCom.Plugin.use('!./plugin/MovieBookView/MovieBookView').then(function(MovieBookView){
                                        MovieBookView.instantiate(data, $('#mticket-container'), globalData.pageParam);
                                        BMapCom.Kernel.notify('webPageReady');

                                        BMapCom.Stat.sendOnline({
                                            "da_src":"buyticketpg",
                                            "da_act":"show",
                                            "da_model":"plugin_movie",
                                            "da_trd":"movie"
                                        });
                                    });
                                });
                        });
                    },
                    onDestory: function() {}
                });
        },
        getScheduleData: function() {
            return new BMapCom.Promise(function(resolve, reject) {
                var params = globalData.pageParam,
                    scheSource = new BMapCom.DataSource();

                scheSource
                    .delegate({
                        search: function() {
                            var self = this,
                                query = {
                                    'qt': 'timetable',
                                    'from': 'webview',
                                    'sfrom': 'map',
                                    'uid': params.uid
                                },
                                url = 'http://map.baidu.com/detail?' + jsonToUrl(query);

                                BMapCom.Loader.jsonp(url)
                                    .ok(function(result) {
                                        if (result.data.base) {
                                            self.onSourceLoadFinish(result.data);
                                        }
                                    })
                                    .error(function() {
                                        self.onSourceLoadFailed();
                                    });
                        }
                    })
                    .delegate({
                        onSourceLoadFinish: function(result) {
                            resolve(result);
                        },
                        startSourceLoad: function(opts) {
                            this.search();
                        }
                    });

                scheSource.update();
            });
        }
    }

    return movieTicket
});